/*	This file was created by Billy Tetrud in February 2008. 
	This file is realeased under version 3 of the GNU Public License. See http://www.gnu.org/licenses/
	A copy of GPLv3 should be distributed with this file.
	Email BillyAtLima@gmail.com if you want to discuss creating a different license.
	Copyright 2008, Billy Tetrud.
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License 
	as published by the Free Software Foundation; either version 3, or (at your option) any later version.

	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
*/

/*	For	anyone interested, this file was created with the intent of being ported to C at some point. Since STL isn't 
	available for C, I would have to impliment something like this myself.
*/

#ifndef BillysBasicDynamicTypes
#define BillysBasicDynamicTypes

#include "neccessaryFunctions080106.h"

// Dynamic list, automaticaly grows - never goes out of bounds (except for negative index)
// must not contain a class that contains pointers nor a reference of any distance to such a class 
template <class T,int startSize=5>
class BDArr		// basic dynamic list
{public:
	T* list;
	int theSize, length;
	
	// creates an empty list
	BDArr()		
	{	length=0;
		theSize=startSize;
		listloc(list,startSize);
	}
	
	~BDArr()
	{	free(list);
		list=0;
		length=0;
		theSize=0;
	}
	
	// Doubles the size of the list
	// returns true on failure
	bool grow()
	{	if(rloc(list, theSize*2*sizeof(T)))
			return true;
		theSize*=2;
		return false;
	}
	
	// halves the size of the list
	void shrink()
	{	theSize/=2;
		rloc(list, theSize*sizeof(T));
	}
	
	// bracket operator for usual array access
	T& operator [](int n)
	{	if(n>=theSize)
		{	if(grow())
				return *((T*)0);	// out of memory - yeah.. thats supposed to give an error
			return (*this)[n];
		}
		if(n>=length)
		{	length = n+1;
		}
		return list[n];
	}
	
	// returns the size
	int size()
	{	return theSize;
	}
	
	int len()
	{	return length;
	}

	BDArr<T> operator =(BDArr<T> a)
	{	for(int n=0; n<a.length; n++)
		{	list[n]=a.list[n];
		}
		length = a.length;
	}

};

#endif
