/*	This file was created by Billy Tetrud in January 2008. 
	This file is realeased under version 3 of the GNU Public License. See http://www.gnu.org/licenses/
	A copy of GPLv3 should be distributed with this file.
	Email BillyAtLima@gmail.com if you want to discuss creating a different license.
	Copyright 2008, Billy Tetrud.
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License 
	as published by the Free Software Foundation; either version 3, or (at your option) any later version.

	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
*/
#ifndef BillysNeccessaryFunctions
#define BillysNeccessaryFunctions

#include <stdlib.h>

// replacement for the realloc function
// in is the size coming in, and out is the size going out
// returns true on failure
template <class T>
bool rloc(T*& a, /*int in,*/ int out)
{	T* temp;
	//temp = (T*)malloc(out);
	temp = (T*)realloc(a, out);
	
	if(temp!=0)
	{	/*int m;
		for(m=0; m+3<in && m+3<out; m+=4)
		{	((int*)temp)[m/4] = ((int*)a)[m/4];
		}
		for(; m<in && m<out; m++)
		{	((char*)temp)[m] = ((char*)a)[m];
		}
		free(a);	// returns resources
		*/
		a=temp;
		return false;	// no error
	}
	else
	{	return true;		// failure
	}
}


// allocates memory for a list - n is the number of elements wanted
// does not free any resources
// returns true on failure
template <class T>
bool listloc(T*& a, int n)
{	a = (T*)malloc(n*sizeof(T));

	if(a!=0)
	{	return false;	// no error
	}
	else
	{	true;		// failure
	}
}

// replacement for the malloc function
// out is the size going out
// returns true on failure
template <class T>
bool mloc(T*& a, int out)
{	a = (T*)malloc(out);
	
	if(a!=0)
	{	return false;	// no error
	}
	else
	{	return true;		// failure
	}
}

#endif
